# sf_command

            int    sf_command (SNDFILE *sndfile, int cmd, void *data, int datasize) ;

This function allows the caller to retrieve information from or change aspects of the library behaviour. Examples include retrieving a string containing the library version or changing the scaling applied to floating point sample data during read and write. Most of these operations are performed on a per-file basis.

The cmd parameter is an integer identifier which is defined in <sndfile.h>. All of the valid command identifiers have names beginning with "SFC_". Data is passed to and returned from the library by use of a void pointer. The library will not read or write more than datasize bytes from the void pointer. For some calls no data is required in which case data should be NULL and datasize may be used for some other purpose.

The available commands are as follows:

SFC_GET_LIB_VERSION | Retrieve the version of the library.
SFC_GET_LOG_INFO | Retrieve the internal per-file operation log.
SFC_CALC_SIGNAL_MAX | Calculate the measured maximum signal value.
SFC_CALC_NORM_SIGNAL_MAX | Calculate the measured normalised maximum signal value.
SFC_CALC_MAX_ALL_CHANNELS | Calculate the peak value for each channel.
SFC_CALC_NORM_MAX_ALL_CHANNELS | Calculate the normalised peak for each channel.
SFC_GET_SIGNAL_MAX | Retrieve the peak value for the file (as stored in the file header).
SFC_GET_MAX_ALL_CHANNELS | Retrieve the peak value for each channel (as stored in the file header).
SFC_SET_NORM_FLOAT | Modify the normalisation behaviour of the floating point reading and writing functions.
SFC_SET_NORM_DOUBLE | Modify the normalisation behaviour of the double precision floating point reading and writing functions.
SFC_GET_NORM_FLOAT | Retrieve the current normalisation behaviour of the floating point reading and writing functions.
SFC_GET_NORM_DOUBLE | Retrieve the current normalisation behaviour of the double precision floating point reading and writing functions.
SFC_SET_SCALE_FLOAT_INT_READ | Set/clear the scale factor when integer (short/int) data is read from a file containing floating point data.
SFC_SET_SCALE_INT_FLOAT_WRITE | Set/clear the scale factor when integer (short/int) data is written to a file as floating point data.
SFC_GET_SIMPLE_FORMAT_COUNT | Retrieve the number of simple formats supported by libsndfile.
SFC_GET_SIMPLE_FORMAT | Retrieve information about a simple format.
SFC_GET_FORMAT_INFO | Retrieve information about a major or subtype format.
SFC_GET_FORMAT_MAJOR_COUNT | Retrieve the number of major formats.
SFC_GET_FORMAT_MAJOR | Retrieve information about a major format type.
SFC_GET_FORMAT_SUBTYPE_COUNT | Retrieve the number of subformats.
SFC_GET_FORMAT_SUBTYPE | Retrieve information about a subformat.
SFC_SET_ADD_PEAK_CHUNK | Switch the code for adding the PEAK chunk to WAV and AIFF files on or off.
SFC_UPDATE_HEADER_NOW | Used when a file is open for write, this command will update the file header to reflect the data written so far.
SFC_SET_UPDATE_HEADER_AUTO | Used when a file is open for write, this command will cause the file header to be updated after each write to the file.
SFC_FILE_TRUNCATE | Truncate a file open for write or for read/write.
SFC_SET_RAW_START_OFFSET | Change the data start offset for files opened up as SF_FORMAT_RAW.
SFC_SET_CLIPPING | Turn on/off automatic clipping when doing floating point to integer conversion.
SFC_GET_CLIPPING | Retrieve current clipping setting.
SFC_GET_EMBED_FILE_INFO | Retrieve information about audio files embedded inside other files.
SFC_GET_AMBISONIC | Test a WAVEX file for Ambisonic format
SFC_SET_AMBISONIC | Modify a WAVEX header for Ambisonic format
SFC_SET_VBR_ENCODING_QUALITY | Set the Variable Bit Rate encoding quality
SFC_SET_COMPRESSION_LEVEL | Set the compression level.
SFC_RAW_NEEDS_ENDSWAP | Determine if raw data needs endswapping
SFC_GET_BROADCAST_INFO | Retrieve the Broadcast Chunk info
SFC_SET_BROADCAST_INFO | Set the Broadcast Chunk info
SFC_SET_CART_INFO | Set the Cart Chunk info
SFC_GET_CART_INFO | Retrieve the Cart Chunk info
SFC_GET_LOOP_INFO | Get loop info
SFC_GET_INSTRUMENT | Get instrument info
SFC_SET_INSTRUMENT | Set instrument info

##
SFC_GET_LIB_VERSION

Retrieve the version of the library as a string.

Parameters:

            sndfile  : Not used
            cmd      : SFC_GET_LIB_VERSION
            data     : A pointer to a char buffer
            datasize : The size of the the buffer

Example:

            char  buffer [128] ;
            sf_command (NULL, SFC_GET_LIB_VERSION, buffer, sizeof (buffer)) ;

Return value:
  This call will return the length of the retrieved version string.

Notes:
  The string returned in the buffer passed to this function will not overflow the buffer and will always be null terminated .

##
SFC_GET_LOG_INFO

Retrieve the log buffer generated when opening a file as a string. This log buffer can often contain a good reason for why libsndfile failed to open a particular file.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_LOG_INFO
            data     : A pointer to a char buffer
            datasize : The size of the the buffer

Example:

            char  buffer [2048] ;
            sf_command (sndfile, SFC_GET_LOG_INFO, buffer, sizeof (buffer)) ;

Return value:
  This call will return the length of the retrieved version string.

Notes:
  The string returned in the buffer passed to this function will not overflow the buffer and will always be null terminated .

##
SFC_CALC_SIGNAL_MAX

Retrieve the measured maximum signal value. This involves reading through the whole file which can be slow on large files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_CALC_SIGNAL_MAX
            data     : A pointer to a double
            datasize : sizeof (double)

Example:

            double   max_val ;
            sf_command (sndfile, SFC_CALC_SIGNAL_MAX, &max_val, sizeof (max_val)) ;

Return value:
  Zero on success, non-zero otherwise.

##
SFC_CALC_NORM_SIGNAL_MAX

Retrieve the measured normalised maximum signal value. This involves reading through the whole file which can be slow on large files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_CALC_NORM_SIGNAL_MAX
            data     : A pointer to a double
            datasize : sizeof (double)

Example:

            double   max_val ;
            sf_command (sndfile, SFC_CALC_NORM_SIGNAL_MAX, &max_val, sizeof (max_val)) ;

Return value:
  Zero on success, non-zero otherwise.

##
SFC_CALC_MAX_ALL_CHANNELS

Calculate the peak value (ie a single number) for each channel. This involves reading through the whole file which can be slow on large files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_CALC_MAX_ALL_CHANNELS
            data     : A pointer to a double
            datasize : sizeof (double) * number_of_channels

Example:

            double   peaks [number_of_channels] ;
            sf_command (sndfile, SFC_CALC_MAX_ALL_CHANNELS, peaks, sizeof (peaks)) ;

Return value:
  Zero if peaks have been calculated successfully and non-zero otherwise.

##
SFC_CALC_NORM_MAX_ALL_CHANNELS

Calculate the normalised peak for each channel. This involves reading through the whole file which can be slow on large files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_CALC_NORM_MAX_ALL_CHANNELS
            data     : A pointer to a double
            datasize : sizeof (double) * number_of_channels

Example:

            double   peaks [number_of_channels] ;
            sf_command (sndfile, SFC_CALC_NORM_MAX_ALL_CHANNELS, peaks, sizeof (peaks)) ;

Return value:
  Zero if peaks have been calculated successfully and non-zero otherwise.

##
SFC_GET_SIGNAL_MAX

Retrieve the peak value for the file as stored in the file header.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_SIGNAL_MAX
            data     : A pointer to a double
            datasize : sizeof (double)

Example:

            double   max_peak ;
            sf_command (sndfile, SFC_GET_SIGNAL_MAX, &max_peak, sizeof (max_peak)) ;

Return value:
  SF_TRUE if the file header contained the peak value. SF_FALSE otherwise.

##
SFC_GET_MAX_ALL_CHANNELS

Retrieve the peak value for the file as stored in the file header.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_SIGNAL_MAX
            data     : A pointer to an array of doubles
            datasize : sizeof (double) * number_of_channels

Example:

            double   peaks [number_of_channels] ;
            sf_command (sndfile, SFC_GET_MAX_ALL_CHANNELS, peaks, sizeof (peaks)) ;

Return value:
  SF_TRUE if the file header contains per channel peak values for the file. SF_FALSE otherwise.

##
SFC_SET_NORM_FLOAT

This command only affects data read from or written to using the floating point functions:

    	size_t    sf_read_float    (SNDFILE *sndfile, float *ptr, size_t items) ;
    	size_t    sf_readf_float   (SNDFILE *sndfile, float *ptr, size_t frames) ;

    	size_t    sf_write_float   (SNDFILE *sndfile, float *ptr, size_t items) ;
    	size_t    sf_writef_float  (SNDFILE *sndfile, float *ptr, size_t frames) ;

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_NORM_FLOAT
            data     : NULL
            datasize : SF_TRUE or SF_FALSE

For read operations setting normalisation to SF_TRUE means that the data from all subsequent reads will be be normalised to the range [-1.0, 1.0].

For write operations, setting normalisation to SF_TRUE means than all data supplied to the float write functions should be in the range [-1.0, 1.0] and will be scaled for the file format as necessary.

For both cases, setting normalisation to SF_FALSE means that no scaling will take place.

Example:

            sf_command (sndfile, SFC_SET_NORM_FLOAT, NULL, SF_TRUE) ;

            sf_command (sndfile, SFC_SET_NORM_FLOAT, NULL, SF_FALSE) ;

Return value:
  Returns the previous float normalisation mode.

##
SFC_SET_NORM_DOUBLE

This command only affects data read from or written to using the double precision floating point functions:

    	size_t    sf_read_double    (SNDFILE *sndfile, double *ptr, size_t items) ;
    	size_t    sf_readf_double   (SNDFILE *sndfile, double *ptr, size_t frames) ;

    	size_t    sf_write_double   (SNDFILE *sndfile, double *ptr, size_t items) ;
    	size_t    sf_writef_double  (SNDFILE *sndfile, double *ptr, size_t frames) ;

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_NORM_DOUBLE
            data     : NULL
            datasize : SF_TRUE or SF_FALSE

For read operations setting normalisation to SF_TRUE means that the data from all subsequent reads will be be normalised to the range [-1.0, 1.0].

For write operations, setting normalisation to SF_TRUE means than all data supplied to the double write functions should be in the range [-1.0, 1.0] and will be scaled for the file format as necessary.

For both cases, setting normalisation to SF_FALSE means that no scaling will take place.

Example:

            sf_command (sndfile, SFC_SET_NORM_DOUBLE, NULL, SF_TRUE) ;

            sf_command (sndfile, SFC_SET_NORM_DOUBLE, NULL, SF_FALSE) ;

Return value:
  Returns the previous double normalisation mode.

##
SFC_GET_NORM_FLOAT

Retrieve the current float normalisation mode.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_NORM_FLOAT
            data     : NULL
            datasize : anything

Example:

            normalisation = sf_command (sndfile, SFC_GET_NORM_FLOAT, NULL, 0) ;

Return value:
  Returns TRUE if normalisation is on and FALSE otherwise.

##
SFC_GET_NORM_DOUBLE

Retrieve the current float normalisation mode.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_NORM_DOUBLE
            data     : NULL
            datasize : anything

Example:

            normalisation = sf_command (sndfile, SFC_GET_NORM_DOUBLE, NULL, 0) ;

Return value:
  Returns TRUE if normalisation is on and FALSE otherwise.

##
SFC_SET_SCALE_FLOAT_INT_READ

Set/clear the scale factor when integer (short/int) data is read from a file containing floating point data.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_SCALE_FLOAT_INT_READ
            data     : NULL
            datasize : TRUE or FALSE

Example:

            sf_command (sndfile, SFC_SET_SCALE_FLOAT_INT_READ, NULL, SF_TRUE) ;

Return value:
  Returns the previous SFC_SET_SCALE_FLOAT_INT_READ setting for this file.

##
SFC_SET_SCALE_INT_FLOAT_WRITE

Set/clear the scale factor when integer (short/int) data is written to a file as floating point data.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_SCALE_FLOAT_INT_READ
            data     : NULL
            datasize : TRUE or FALSE

Example:

            sf_command (sndfile, SFC_SET_SCALE_INT_FLOAT_WRITE, NULL, SF_TRUE) ;

Return value:
  Returns the previous SFC_SET_SCALE_INT_FLOAT_WRITE setting for this file.

##
SFC_GET_SIMPLE_FORMAT_COUNT

Retrieve the number of simple formats supported by libsndfile.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_SIMPLE_FORMAT_COUNT
            data     : a pointer to an int
            datasize : sizeof (int)

Example:

            int  count ;
            sf_command (sndfile, SFC_GET_SIMPLE_FORMAT_COUNT, &count, sizeof (int)) ;

Return value:
  0

##
SFC_GET_SIMPLE_FORMAT

Retrieve information about a simple format.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_SIMPLE_FORMAT
            data     : a pointer to an  SF_FORMAT_INFO struct
            datasize : sizeof (SF_FORMAT_INFO)

The SF_FORMAT_INFO struct is defined in <sndfile.h> as:

            typedef struct
            {   int         format ;
                const char  *name ;
                const char  *extension ;
            } SF_FORMAT_INFO ;

When sf_command() is called with SF_GET_SIMPLE_FORMAT, the value of the format field should be the format number (ie 0 <= format <= count value obtained using SF_GET_SIMPLE_FORMAT_COUNT).

Example:

            SF_FORMAT_INFO	format_info ;
            int             k, count ;

            sf_command (sndfile, SFC_GET_SIMPLE_FORMAT_COUNT, &count, sizeof (int)) ;

            for (k = 0 ; k < count ; k++)
            {   format_info.format = k ;
                sf_command (sndfile, SFC_GET_SIMPLE_FORMAT, &format_info, sizeof (format_info)) ;
                printf ("%08x  %s %s\n", format_info.format, format_info.name, format_info.extension) ;
                } ;

Return value:
  0 on success and non-zero otherwise.
  The value of the format field of the SF_FORMAT_INFO struct will be a value which can be placed in the format field of an SF_INFO struct when a file is to be opened for write.
  The name field will contain a char* pointer to the name of the string, eg. "WAV (Microsoft 16 bit PCM)".
  The extension field will contain the most commonly used file extension for that file type.

##
SFC_GET_FORMAT_INFO

Retrieve information about a major or subtype format.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_FORMAT_INFO
            data     : a pointer to an SF_FORMAT_INFO struct
            datasize : sizeof (SF_FORMAT_INFO)

The SF_FORMAT_INFO struct is defined in <sndfile.h> as:

            typedef struct
            {   int         format ;
                const char  *name ;
                const char  *extension ;
            } SF_FORMAT_INFO ;

When sf_command() is called with SF_GET_FORMAT_INFO, the format field is examined and if (format & SF_FORMAT_TYPEMASK) is a valid format then the struct is filled in with information about the given major type. If (format & SF_FORMAT_TYPEMASK) is FALSE and (format & SF_FORMAT_SUBMASK) is a valid subtype format then the struct is filled in with information about the given subtype.

Example:

            SF_FORMAT_INFO	format_info ;

            format_info.format = SF_FORMAT_WAV ;
            sf_command (sndfile, SFC_GET_FORMAT_INFO, &format_info, sizeof (format_info)) ;
            printf ("%08x  %s %s\n", format_info.format, format_info.name, format_info.extension) ;

            format_info.format = SF_FORMAT_ULAW ;
            sf_command (sndfile, SFC_GET_FORMAT_INFO, &format_info, sizeof (format_info)) ;
            printf ("%08x  %s\n", format_info.format, format_info.name) ;

Return value:
  0 on success and non-zero otherwise.

##
SFC_GET_FORMAT_MAJOR_COUNT

Retrieve the number of major formats.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_FORMAT_MAJOR_COUNT
            data     : a pointer to an int
            datasize : sizeof (int)

Example:

            int  count ;
            sf_command (sndfile, SFC_GET_FORMAT_MAJOR_COUNT, &count, sizeof (int)) ;

Return value:
  0

##
SFC_GET_FORMAT_MAJOR

Retrieve information about a major format type.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_FORMAT_MAJOR
            data     : a pointer to an  SF_FORMAT_INFO struct
            datasize : sizeof (SF_FORMAT_INFO)

Example:

            SF_FORMAT_INFO	format_info ;
            int             k, count ;

            sf_command (sndfile, SFC_GET_FORMAT_MAJOR_COUNT, &count, sizeof (int)) ;

            for (k = 0 ; k < count ; k++)
            {   format_info.format = k ;
                sf_command (sndfile, SFC_GET_FORMAT_MAJOR, &format_info, sizeof (format_info)) ;
                printf ("%08x  %s %s\n", format_info.format, format_info.name, format_info.extension) ;
                } ;

For a more comprehensive example, see the program list_formats.c in the examples/ directory of the libsndfile source code distribution.

Return value:
  0 on success and non-zero otherwise.
  The value of the format field will be one of the major format identifiers such as SF_FORMAT_WAV or SF_FORMAT_AIFF.
  The name field will contain a char* pointer to the name of the string, eg. "WAV (Microsoft)".
  The extension field will contain the most commonly used file extension for that file type.

##
SFC_GET_FORMAT_SUBTYPE_COUNT

Retrieve the number of subformats.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_FORMAT_SUBTYPE_COUNT
            data     : a pointer to an int
            datasize : sizeof (int)

Example:

            int   count ;
            sf_command (sndfile, SFC_GET_FORMAT_SUBTYPE_COUNT, &count, sizeof (int)) ;

Return value:
  0

##
SFC_GET_FORMAT_SUBTYPE

Enumerate the subtypes (this function does not translate a subtype into a string describing that subtype). A typical use case might be retrieving a string description of all subtypes so that a dialog box can be filled in.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_FORMAT_SUBTYPE
            data     : a pointer to an SF_FORMAT_INFO struct
            datasize : sizeof (SF_FORMAT_INFO)

Example 1: Retrieve all sybtypes supported by the WAV format.

            SF_FORMAT_INFO	format_info ;
            int             k, count ;

            sf_command (sndfile, SFC_GET_FORMAT_SUBTYPE_COUNT, &count, sizeof (int)) ;

            for (k = 0 ; k < count ; k++)
            {   format_info.format = k ;
                sf_command (sndfile, SFC_GET_FORMAT_SUBTYPE, &format_info, sizeof (format_info)) ;
                if (! sf_format_check (format_info.format | SF_FORMAT_WAV))
                   continue ;
                printf ("%08x  %s\n", format_info.format, format_info.name) ;
                } ;

Example 2: Print a string describing the SF_FORMAT_PCM_16 subtype.

            SF_FORMAT_INFO	format_info ;
            int             k, count ;

            sf_command (sndfile, SFC_GET_FORMAT_SUBTYPE_COUNT, &count, sizeof (int)) ;

            for (k = 0 ; k < count ; k++)
            {   format_info.format = k ;
                sf_command (sndfile, SFC_GET_FORMAT_SUBTYPE, &format_info, sizeof (format_info)) ;
                if (format_info.format == SF_FORMAT_PCM_16)
                {   printf ("%08x  %s\n", format_info.format, format_info.name) ;
                    break ;
                    } ;
                } ;

For a more comprehensive example, see the program list_formats.c in the examples/ directory of the libsndfile source code distribution.

Return value:
  0 on success and non-zero otherwise.
  The value of the format field will be one of the major format identifiers such as SF_FORMAT_WAV or SF_FORMAT_AIFF.
  The name field will contain a char* pointer to the name of the string; for instance "WAV (Microsoft)" or "AIFF (Apple/SGI)".
  The extension field will be a NULL pointer.

##
SFC_SET_ADD_PEAK_CHUNK

By default, WAV and AIFF files which contain floating point data (subtype SF_FORMAT_FLOAT or SF_FORMAT_DOUBLE) have a PEAK chunk. By using this command, the addition of a PEAK chunk can be turned on or off.

Note : This call must be made before any data is written to the file.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_ADD_PEAK_CHUNK
            data     : Not used (should be NULL)
            datasize : TRUE or FALSE.

Example:

            /* Turn on the PEAK chunk. */
            sf_command (sndfile, SFC_SET_ADD_PEAK_CHUNK, NULL, SF_TRUE) ;

            /* Turn off the PEAK chunk. */
            sf_command (sndfile, SFC_SET_ADD_PEAK_CHUNK, NULL, SF_FALSE) ;

Return value:
  Returns SF_TRUE if the peak chunk will be written after this call.
  Returns SF_FALSE if the peak chunk will not be written after this call.

##
SFC_UPDATE_HEADER_NOW

The header of an audio file is normally written by libsndfile when the file is closed using sf_close().

There are however situations where large files are being generated and it would be nice to have valid data in the header before the file is complete. Using this command will update the file header to reflect the amount of data written to the file so far. Other programs opening the file for read (before any more data is written) will then read a valid sound file header.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_UPDATE_HEADER_NOW
            data     : Not used (should be NULL)
            datasize : Not used.

Example:

            /* Update the header now. */
            sf_command (sndfile, SFC_UPDATE_HEADER_NOW, NULL, 0) ;

Return value:
  0

##
SFC_SET_UPDATE_HEADER_AUTO

Similar to SFC_UPDATE_HEADER_NOW but updates the header at the end of every call to the sf_write* functions.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_UPDATE_HEADER_NOW
            data     : Not used (should be NULL)
            datasize : SF_TRUE or SF_FALSE

Example:

            /* Turn on auto header update. */
            sf_command (sndfile, SFC_SET_UPDATE_HEADER_AUTO, NULL, SF_TRUE) ;

            /* Turn off auto header update. */
            sf_command (sndfile, SFC_SET_UPDATE_HEADER_AUTO, NULL, SF_FALSE) ;

Return value:
  TRUE if auto update header is now on; FALSE otherwise.

##
SFC_FILE_TRUNCATE

Truncate a file that was opened for write or read/write.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_FILE_TRUNCATE
            data     : A pointer to an sf_count_t.
            datasize : sizeof (sf_count_t)

Truncate the file to the number of frames specified by the sf_count_t pointed to by data. After this command, both the read and the write pointer will be at the new end of the file. This command will fail (returning non-zero) if the requested truncate position is beyond the end of the file.

Example:

            /* Truncate the file to a length of 20 frames. */
            sf_count_t  frames = 20 ;
            sf_command (sndfile, SFC_FILE_TRUNCATE, &frames, sizeof (frames)) ;

Return value:
  Zero on sucess, non-zero otherwise.

##
SFC_SET_RAW_START_OFFSET

Change the data start offset for files opened up as SF_FORMAT_RAW.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_RAW_START_OFFSET
            data     : A pointer to an sf_count_t.
            datasize : sizeof (sf_count_t)

For a file opened as format SF_FORMAT_RAW, set the data offset to the value given by data.

Example:

            /* Reset the data offset to 5 bytes from the start of the file. */
            sf_count_t  offset = 5 ;
            sf_command (sndfile, SFC_SET_RAW_START_OFFSET, &offset, sizeof (offset)) ;

Return value:
  Zero on success, non-zero otherwise.

##
SFC_SET_CLIPPING

Turn on/off automatic clipping when doing floating point to integer conversion.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_CLIPPING
            data     : NULL
            datasize : SF_TRUE or SF_FALSE.

Turn on (datasize == SF_TRUE) or off (datasize == SF_FALSE) clipping.

Example:

            sf_command (sndfile, SFC_SET_CLIPPING, NULL, SF_TRUE) ;

Return value:
  Clipping mode (SF_TRUE or SF_FALSE).

##
SFC_GET_CLIPPING

Turn on/off automatic clipping when doing floating point to integer conversion.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_CLIPPING
            data     : NULL
            datasize : 0

Retrieve the current cliiping setting.

Example:

            sf_command (sndfile, SFC_GET_CLIPPING, NULL, 0) ;

Return value:
  Clipping mode (SF_TRUE or SF_FALSE).

##
SFC_GET_EMBED_FILE_INFO

Get the file offset and file length of a file enbedded within another larger file.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_CLIPPING
            data     : a pointer to an  SF_EMBED_FILE_INFO struct
            datasize : sizeof (SF_EMBED_FILE_INFO)

The SF_EMBED_FILE_INFO struct is defined in <sndfile.h> as:

            typedef struct
            {   sf_count_t	offset ;
                sf_count_t	length ;
            } SF_EMBED_FILE_INFO ;

Return value:
  0 on success and non-zero otherwise.
  The value of the offset field of the SF_EMBED_FILE_INFO struct will be the offsets in bytes from the start of the outer file to the start of the audio file.
  The value of the offset field of the SF_EMBED_FILE_INFO struct will be the length in bytes of the embedded file.

##
SFC_WAVEX_GET_AMBISONIC

Test if the current file has the GUID of a WAVEX file for any of the Ambisonic formats.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_WAVEX_GET_AMBISONIC
            data     : NULL
            datasize : 0

The Ambisonic WAVEX formats are defined here : http://dream.cs.bath.ac.uk/researchdev/wave-ex/bformat.html.

Return value:
  SF_AMBISONIC_NONE or SF_AMBISONIC_B_FORMAT or zero if the file format does not support ambisonic formats.

##
SFC_WAVEX_SET_AMBISONIC

Set the GUID of a new WAVEX file to indicate an Ambisonics format.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_WAVEX_SET_AMBISONIC
            data     : NULL
            datasize : SF_AMBISONIC_NONE or SF_AMBISONIC_B_FORMAT

Turn on (SF_AMBISONIC_B_FORMAT) or off (SF_AMBISONIC_NONE) encoding. This command is currently only supported for files with SF_FORMAT_WAVEX format.

The Ambisonic WAVEX formats are defined here : http://dream.cs.bath.ac.uk/researchdev/wave-ex/bformat.html.

Return value:
  Return the ambisonic value that has just been set or zero if the file format does not support ambisonic encoding.

##
SFC_SET_VBR_ENCODING_QUALITY

Set the Variable Bit Rate encoding quality. The encoding quality value should be between 0.0 (lowest quality) and 1.0 (highest quality). Currenly this command is only implemented for FLAC and Ogg/Vorbis files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_VBR_ENCODING_QUALITY
            data     : A pointer to a double value
            datasize : sizeof (double)

The command must be sent before any audio data is written to the file.

Return value:
  SF_TRUE if VBR encoding quality was set. SF_FALSE otherwise.

##
SFC_SET_COMPRESSION_LEVEL

Set the compression level. The compression level should be between 0.0 (minimum compression level) and 1.0 (highest compression level). Currenly this command is only implemented for FLAC and Ogg/Vorbis files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_COMPRESSION_LEVEL
            data     : A pointer to a double value
            datasize : sizeof (double)

The command must be sent before any audio data is written to the file.

Return value:
  SF_TRUE if compression level was set. SF_FALSE otherwise.

##
SFC_RAW_NEEDS_ENDSWAP

Determine if raw data read using sf_read_raw needs to be end swapped on the host CPU.

For instance, will return SF_TRUE on when reading WAV containing SF_FORMAT_PCM_16 data on a big endian machine and SF_FALSE on a little endian machine.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_RAW_NEEDS_ENDSWAP
            data     : NULL
            datasize : 0

Return value:
  SF_TRUE or SF_FALSE

##
SFC_GET_BROADCAST_INFO

Retrieve the Broadcast Extension Chunk from WAV (and related) files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_BROADCAST_INFO
            data     : a pointer to an SF_BROADCAST_INFO struct
            datasize : sizeof (SF_BROADCAST_INFO)

The SF_BROADCAST_INFO struct is defined in <sndfile.h> as:

        typedef struct
        {   char            description [256] ;
            char            originator [32] ;
            char            originator_reference [32] ;
            char            origination_date [10] ;
            char            origination_time [8] ;
            unsigned int    time_reference_low ;
            unsigned int    time_reference_high ;
            short           version ;
            char            umid [64] ;
            char            reserved [190] ;
            unsigned int    coding_history_size ;
            char            coding_history [256] ;
        } SF_BROADCAST_INFO ;

Return value:
  SF_TRUE if the file contained a Broadcast Extension chunk or SF_FALSE otherwise.

##
SFC_SET_BROADCAST_INFO

Set the Broadcast Extension Chunk for WAV (and related) files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_BROADCAST_INFO
            data     : a pointer to an SF_BROADCAST_INFO struct
            datasize : sizeof (SF_BROADCAST_INFO)

Return value:
  SF_TRUE if setting the Broadcast Extension chunk was successful and SF_FALSE otherwise.

##
SFC_GET_CART_INFO

Retrieve the Cart Chunk from WAV (and related) files. Based on AES46 standard for CartChunk (see CartChunk.org for more information.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_CART_INFO
            data     : a pointer to an SF_CART_INFO struct
            datasize : sizeof (SF_CART_INFO)

The SF_CART_INFO struct is defined in <sndfile.h> as:

    #define SF_CART_INFO_VAR(p_tag_text_size) \
                            struct
                            {       char            version [4] ;
                                    char            title [64] ;
                                    char            artist [64] ;
                                    char            cut_id [64] ;
                                    char            client_id [64] ;
                                    char            category [64] ;
                                    char            classification [64] ;
                                    char            out_cue [64] ;
                                    char            start_date [10] ;
                                    char            start_time [8] ;
                                    char            end_date [10] ;
                                    char            end_time [8] ;
                                    char            producer_app_id [64] ;
                                    char            producer_app_version [64] ;
                                    char            user_def [64] ;
                                    long    level_reference ;
                                    SF_CART_TIMER   post_timers [8] ;
                                    char            reserved [276] ;
                                    char            url [1024] ;
                                    unsigned int    tag_text_size ;
                                    char            tag_text[p_tag_text_size] ;
                            }

Return value:
  SF_TRUE if the file contained a Cart chunk or SF_FALSE otherwise.

##
SFC_SET_CART_INFO

Set the Cart Chunk for WAV (and related) files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_CART_INFO
            data     : a pointer to an SF_CART_INFO struct
            datasize : sizeof (SF_CART_INFO)

Return value:
  SF_TRUE if setting the Cart chunk was successful and SF_FALSE otherwise.

##
SFC_GET_LOOP_INFO

Retrieve loop information for file including time signature, length in beats and original MIDI base note

Parameters:

             sndfile  : A valid SNDFILE* pointer
             cmd      : SFC_GET_LOOP_INFO
             data     : a pointer to an SF_LOOP_INFO struct
             datasize : sizeof (SF_LOOP_INFO)

The SF_BROADCAST_INFO struct is defined in <sndfile.h> as:

            typedef struct
            {   short    time_sig_num ;   /* any positive integer    > 0  */
                short    time_sig_den ;   /* any positive power of 2 > 0  */
                int        loop_mode ;    /* see SF_LOOP enum             */

                int        num_beats ;    /* this is NOT the amount of quarter notes !!!*/
                                          /* a full bar of 4/4 is 4 beats */
                                          /* a full bar of 7/8 is 7 beats */

                float    bpm ;            /* suggestion, as it can be calculated using other fields:*/
                                          /* file's lenght, file's sampleRate and our time_sig_den*/
                                          /* -> bpms are always the amount of _quarter notes_ per minute */

                int    root_key ;         /* MIDI note, or -1 for None */
                int future [6] ;
            } SF_LOOP_INFO ;

Example:

             SF_LOOP_INFO loop;
             sf_command (sndfile, SFC_GET_LOOP_INFO, &loop, sizeof (loop)) ;

Return value:
  SF_TRUE if the file header contains loop information for the file. SF_FALSE otherwise.

##
SFC_GET_INSTRUMENT

Retrieve instrument information from file including MIDI base note, keyboard mapping and looping informations(start/stop and mode).

Parameters:

             sndfile  : A valid SNDFILE* pointer
             cmd      : SFC_GET_INSTRUMENT
             data     : a pointer to an SF_INSTRUMENT struct
             datasize : sizeof (SF_INSTRUMENT)

The SF_INSTRUMENT struct is defined in <sndfile.h> as:

            enum
            {    /*
                **    The loop mode field in SF_INSTRUMENT will be one of the following.
                */
                SF_LOOP_NONE = 800,
                SF_LOOP_FORWARD,
                SF_LOOP_BACKWARD,
                SF_LOOP_ALTERNATING
            } ;

            typedef struct
            {   int gain ;
                char basenote, detune ;
                char velocity_lo, velocity_hi ;
                char key_lo, key_hi ;
                int loop_count ;

                struct
                {   int mode ;
                    unsigned int start ;
                    unsigned int end ;
                    unsigned int count ;
                } loops [16] ; /* make variable in a sensible way */
            } SF_INSTRUMENT ;

Example:

             SF_INSTRUMENT inst ;
             sf_command (sndfile, SFC_GET_INSTRUMENT, &inst, sizeof (inst)) ;

Return value:
  SF_TRUE if the file header contains instrument information for the file. SF_FALSE otherwise.

##
SFC_SET_INSTRUMENT

Set the instrument information for the file.

Parameters:

             sndfile  : A valid SNDFILE* pointer
             cmd      : SFC_GET_INSTRUMENT
             data     : a pointer to an SF_INSTRUMENT struct
             datasize : sizeof (SF_INSTRUMENT)

Example:

             SF_INSTRUMENT inst ;
             sf_command (sndfile, SFC_SET_INSTRUMENT, &inst, sizeof (inst)) ;

Return value:
  SF_TRUE if the file header contains instrument information for the file. SF_FALSE otherwise.

The libsndfile home page is here : http://www.mega-nerd.com/libsndfile/.
Version : 1.0.25